// Generated by CoffeeScript 1.7.1

/*
 * jCounter - a simple character counter
 *
 * @author	Maximilian Mader
 * @copyright	2011 - 2013 Maximilian Mader
 * @license	BSD 3-Clause License <http://opensource.org/licenses/BSD-3-Clause>
 * @package	be.bastelstu.max.wcf.jCounter
 */
(function($) {
  var jCounterID, throttle;
  jCounterID = 0;

  /*
  	 * Throttle function <http://remysharp.com/2010/07/21/throttling-function-calls/>
   */
  throttle = function(fn, threshold, scope) {
    var deferTimer, last;
    threshold || (threshold = 250);
    last = 0;
    deferTimer = null;
    return (function(_this) {
      return function() {
        var args, context, now;
        context = scope || _this;
        now = +(new Date);
        args = arguments;
        if (last && now < last + threshold) {
          clearTimeout(deferTimer);
          return deferTimer = setTimeout(function() {
            last = now;
            return fn.apply(context, args);
          }, threshold);
        } else {
          last = now;
          return fn.apply(context, args);
        }
      };
    })(this);
  };

  /*
  	 * See http://chris-spittles.co.uk/jquery-calculate-scrollbar-width/#comment-1603
   */
  $.scrollbarWidth = function() {
    var inner, outer, result, width1, width2;
    inner = $('<div>');
    outer = $('<div>').append(inner);
    $('body').append(outer);
    width1 = inner.prop('offsetWidth');
    outer.css('overflow', 'scroll');
    width2 = outer.prop('clientWidth');
    outer.remove();
    result = width1 - width2;
    $.scrollbarWidth = function() {
      return result;
    };
    return result;
  };
  return $.fn.jCounter = function(container, options) {
    var firstStep, id, jCounter, step, _ref, _ref1;
    if (this.length > 1) {
      return this.each(function(k, v) {
        return $(v).jCounter(container, options);
      });
    }
    if (!this.is('textarea, input[type=text], input[type=password], input[type=search], input[type=email], input[type=url]') || this.hasClass('jsDatePicker')) {
      console.log('[jCounter] Unsupported element ' + (this.prop('tagName') === 'INPUT' ? "INPUT type='" + (this.attr('type')) + "'" : "type " + (this.prop('tagName'))));
      return this;
    }
    if (this.parent().hasClass('jCounterContainer')) {
      return this;
    }
    options = $.extend({
      max: 0,
      countUp: false
    }, options);
    if ((options.colors == null) || options.colors.length < 1) {
      options.colors = ['blue', 'orange', 'red'];
    }
    options.max = (_ref = this.attr('maxlength')) != null ? _ref : options.max;
    if (options.max === 0) {
      options.countUp = true;
    }
    jCounter = (container != null ? typeof container === 'object' ? container : $(container) : (id = (_ref1 = this.attr('id')) != null ? _ref1 : this.attr('id', "jCounterID" + (jCounterID++)).attr('id'), this.addClass('jCounterInput').wrap("<div class=\"jCounterContainer\"></div>").parent().append("<label for=\"" + id + "\" class=\"jCounter badge " + options.colors[0] + "\">" + (options.countUp ? 0 : options.max) + "</label>"), $(this).parent().children(".jCounter").css({
      borderTopRightRadius: this.css('border-top-right-radius'),
      borderBottomRightRadius: this.css('border-bottom-right-radius'),
      borderBottomLeftRadius: this.css('border-bottom-left-radius'),
      borderTopLeftRadius: this.css('border-top-left-radius')
    })));
    firstStep = options.max * (1 / options.colors.length) * 1.5;
    step = (options.max - firstStep) / (options.colors.length - 1);
    this.on('input change', throttle((function(_this) {
      return function() {
        var color, index, length;
        length = _this.val().length;
        color = (options.max > 0 && options.colors.length > 0 ? length < firstStep ? options.colors[0] : (index = Math.floor((length - firstStep) / step) + 1, index < options.colors.length ? options.colors[index] : options.colors[options.colors.length - 1]) : options.colors[0]);
        jCounter.text(options.countUp ? length : options.max - length).removeClass(options.colors.join(' ')).addClass(color);
        if (container == null) {
          jCounter.css('top', parseFloat(_this.css('border-top-width')) + parseFloat(_this.css('margin-top')) + 1);
          jCounter.css('bottom', parseFloat(_this.css('border-bottom-width')) + parseFloat(_this.css('margin-bottom')) + 1);
          jCounter.css('margin-left', -(jCounter.outerWidth() + parseFloat(_this.css('border-right-width')) + parseFloat(_this.css('margin-right')) + 1) - (_this[0].type === 'textarea' ? $.scrollbarWidth() : 0));
          return _this.css('padding-right', 3 + jCounter.outerWidth());
        }
      };
    })(this), 16));
    return this.trigger('change');
  };
})(jQuery);
